// Smart.cpp : ܼ  α׷   մϴ.
//

#include <stdio.h>
#include <string.h>
////////////////////

#include "windows.h"
#include "dclib.h"
#pragma comment( lib, "dclib.lib" )

#include "EvImgShow.h"
#pragma comment( lib, "EvImgShow.lib" )

////////////////////

int main(int argc, char* argv[])
{
	////////////////

	int nBrd = 0;
	int nChn = 0;

	DWORD dwDllVer = 0;
	DWORD dwDrvVer = 0;
	DWORD dwChipVer = 0;

	// Sensor Image Info
	int nWidth = 640;
	int nHeight = 480;
	int nDataSize = nWidth * nHeight * 2; 

	// Frame Buffer
	int nFrmBufNum = 20;

	int ret;
	float fRet;

	unsigned char buf[64];

	BYTE* pDataPtr = NULL;
	WORD nGrabLen = 0;
	int nLoop = 0;

	//// Gray-Raw : 101, Gary-4Pack : 102, RGB : 111, RGB-4Pack : 112, Y422(UYVY) : 201
	int nDataType = 201;

	////////////////

	printf( "[ Board Init ]\r\n" );

	printf( "Board Num : %d,   Channel Num : %d\r\n", nBrd, nChn );

	ret = DC_Init();
	if ( ret != 0 ) printf( "DC_Init() : Fail (0x%X)\r\n", ret );

	ret = DC_GetVersion( nBrd, &dwDllVer, &dwDrvVer, &dwChipVer );
	if ( ret != 0 ) printf( "DC_GetVersion() : Fail (0x%X)\r\n", ret );
	printf( "DllVer : 0x%X, DrvVer : 0x%X, ChipVer : 0x%X\r\n", dwDllVer, dwDrvVer, dwChipVer );

	ret = DC_SetSpiI2cMode(nBrd, 1);
	if ( ret != 0 ) printf( "DC_SetSpiI2cMode() : Fail (0x%X)\r\n", ret );

	fRet = DC_SetClkFreq(nBrd, 24.0f);
	printf( "DC_SetClkFreq() : %f\r\n", fRet );

	fRet = DC_SetSpiFreq(nBrd, 1.0f);
	printf( "DC_SetSpiFreq() : %f\r\n", fRet );

	fRet = DC_SetHwI2cFreq(nBrd, 200.0f);
	printf( "DC_SetHwI2cFreq() :%f\r\n", fRet );

	ret = DC_SetMipiInfo(nBrd, nChn, 0, 30);
	if ( ret != 0 ) printf( "DC_SetMipiInfo() : Fail (0x%X)\r\n", ret );

	ret = DC_SetCapInfo(nBrd, nChn, 0, 0, 1, 1, 1, 0, 0, 0);
	if ( ret != 0 ) printf( "DC_SetCapInfo() : Fail (0x%X)\r\n", ret );

	ret = DC_Open(nBrd, nChn, nHeight, nWidth*2, nFrmBufNum, 8);
	if ( ret != 0 ) printf( "DC_Open() : Fail (0x%X)\r\n", ret );
	////////////////

	////////////////
	printf( "[ Mipi Init ]\r\n" );

	buf[0]=0xCA; buf[1]=0x21; buf[2]=0x01;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0xCA; buf[1]=0x04; buf[1]=0x00;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0xCA; buf[1]=0x22, buf[2]=0x00;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0xCA; buf[1]=0x23, buf[2]=0x1E;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0xCA; buf[1]=0x20, buf[2]=0x03;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0xCA; buf[1]=0x21, buf[2]=0x00;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );
	////////////////

	////////////////
	printf( "[ Camera Reset ]\r\n" );

	buf[0]=0xCA; buf[1]=0x03, buf[2]=0x01;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	Sleep(2);

	buf[0]=0xCA; buf[1]=0x03, buf[2]=0x00;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	Sleep(10);
	////////////////

	////////////////
	printf( "[ Camera  - CE1502 ]\r\n" );

	buf[0]=0x78; buf[1]=0xF0;
	ret = DC_HwI2cWrite(nBrd, 2, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	Sleep(700);
	printf( "Sleep : 700ms\r\n" );
	
	buf[0]=0x78; buf[1]=0x54; buf[2]=0x0B; buf[3]=0x00;
	ret = DC_HwI2cWrite(nBrd, 4, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0x78; buf[1]=0x5A; buf[2]=0x3C; buf[3]=0x00;
	ret = DC_HwI2cWrite(nBrd, 4, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );

	buf[0]=0x78; buf[1]=0x6B; buf[2]=0x01;
	ret = DC_HwI2cWrite(nBrd, 3, 1, 1, buf );
	if ( ret != 0 ) printf( "DC_HwI2cWrite() : Fail (0x%X)\r\n", ret );
	////////////////

	////////////////
	printf( "[ Camera  ]\r\n" );

	ret = DC_SetCapInfo(nBrd, nChn, 0, 0, 1, 1, 1, 0, 0, 0);
	if ( ret != 0 ) printf( "DC_SetCapInfo() : Fail (0x%X)\r\n", ret );

	ret = DC_Start(nBrd, nChn);
	if ( ret != 0 ) printf( "DC_Start() : Fail (0x%X)\r\n", ret );
	////////////////

	////////////////
	printf( "[ Get Frame ]\r\n" );

	while ( nGrabLen < 1 )
	{
		Sleep(1);
		if ( nLoop > 5000 ) break;
		nLoop += 1;
		DC_GetFrame(nBrd, nChn, 0, &pDataPtr, &nGrabLen, 0 );
	}

	printf( "Press any key to quit on the image screen !\r\n" );

	evShowImage( "image", nWidth, nHeight, pDataPtr, nDataSize, nDataType );

	evWaitKey(0);
	////////////////

	////////////////
	printf( "[  ]\r\n" );

	ret = DC_Stop(nBrd, nChn);
	if ( ret != 0 ) printf( "DC_Stop() : Fail (0x%X)\r\n", ret );

	ret = DC_Close(nBrd, nChn);
	if ( ret != 0 ) printf( "DC_Close() : Fail (0x%X)\r\n", ret );

	ret = DC_End();
	if ( ret != 0 ) printf( "DC_End() : Fail (0x%X)\r\n", ret );
	////////////////

	return 0;
}

////////////////////
