// Card.cpp: implementation of the CCard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "View.h"
#include "dclibdef.h"
#include "Card.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CDigitalCaptureLib::CCard()
{
	cur_card = 0;
}

CDigitalCaptureLib::~CCard()
{
}

int CDigitalCaptureLib::Init()
{
	return DC_Init()
}

int CDigitalCaptureLib::End()
{
	return DC_End()
}

int CDigitalCaptureLib::SelectCard(int card_num)
{
	if (card_num<DC_GetMaxCards()) {
		cur_card = card_num;
	}
	return 0;
}


int CDigitalCaptureLib::GetMaxCards()
{
	return DC_GetMaxCards();
}

int CDigitalCaptureLib::GetCurCard()
{
	return cur_card;
}

int CDigitalCaptureLib::GetVersion(DWORD *DllVer,DWORD *DrvVer,DWORD *ChipVer)
{
	return DC_GetVersion(cur_card,DllVer,DrvVer,ChipVer);
}

int CDigitalCaptureLib::GetMaxChannels()
{
	return DC_GetMaxChannels(cur_card);
}

int CDigitalCaptureLib::WriteReg(DWORD offset,DWORD data)
{
	return DC_WriteReg(cur_card,offset,data);
}

int CDigitalCaptureLib::ReadReg(DWORD offset,DWORD *data)
{
	return DC_ReadReg(cur_card,offset,data);
}

int CDigitalCaptureLib::GenIoIrqSet(DWORD ipen, DWORD inen)
{
	return DC_GenIoIrqSet(cur_card,ipen,inen);
}

int CDigitalCaptureLib::GenIoRead(DWORD *data)
{
	return DC_GenIoRead(cur_card,data);
}

int CDigitalCaptureLib::GenIoReadOvl(DWORD *data,DWORD *status)
{
	return DC_GenIoReadOvl(cur_card,data,status);
}

int CDigitalCaptureLib::GenIoCancelReadOvl()
{
	return DC_GenIoCancelReadOvl(cur_card);
}

int CDigitalCaptureLib::GenIoWrite(DWORD data)
{
	return DC_GenIoWrite(cur_card,data);
}


int CDigitalCaptureLib::GpioReadIn(int card_num,DWORD *data)
{
	return DC_GpioReadIn(cur_card,data);
}

int CDigitalCaptureLib::GpioWriteOut(int card_num,DWORD data)
{
	return DC_GpioWriteOut(cur_card,data);
}

int CDigitalCaptureLib::GpioWriteOE(DWORD data)
{
	return DC_GpioWriteOE(cur_card,data);
}

int CDigitalCaptureLib::Open(int channel,int Height,int Width,int Frames,int BitsPerClk)
{
	return DC_Open(cur_card,channel,Height,Width,Frames,BitsPerClk);
}

int CDigitalCaptureLib::Close(int channel)
{
	return DC_Close(cur_card,channel);
}


int CDigitalCaptureLib::Start(int channel)
{
	return DC_Start(cur_card,channel);
}

int CDigitalCaptureLib::Stop(int channel)
{
	return DC_Stop(cur_card,channel);
}



int CDigitalCaptureLib::GetFrame(int channel, BYTE **buf,WORD *pos)
{
	return DC_GetFrame(cur_card,channel,buf,pos);
}

int CDigitalCaptureLib::GetFrameAtPos(int channel, WORD pos,BYTE **buf)
{
	return DC_GetFrameAtPos(cur_card,channel,pos,buf);
}

int CDigitalCaptureLib::CancelGetFrame(int channel)
{
	return DC_CancelGetFrame(cur_card,channel);
}


int CDigitalCaptureLib::SetCameraCableMode(int card_num,int channel,int mode)
{
	return DC_SetCameraCableMode(cur_card,channel,mode);
}


int CDigitalCaptureLib::SetCapInfo(int channel,int HBP, int VBP, int ClkEdgeHigh, int HSyncHigh, int VSyncHigh, int LineArea, int Input10Bits)
{
	return DC_SetCapInfo(cur_card,channel,HBP, VBP, ClkEdgeHigh, HSyncEdgeHigh, VSyncEdgeHigh, LineArea, Input10Bits);
}

int CDigitalCaptureLib::SetFilter(int channel,DWORD mode,DWORD fsHz,DWORD cutoffHz,int offset,float q)
{
	return DC_SetFilter(cur_card,channel,mode,fsHz,cutoffHz,offset,q);
}

int CDigitalCaptureLib::SetExposure(int channel,int enable,int active_high,int width)
{
	return DC_SetExposure(cur_card,channel,enable,ActiveHigh,width);
}

int CDigitalCaptureLib::SetLookupTable(int channel,int index, WORD value)
{
	return DC_SetLookupTable(cur_card,channel,index,value);
}

// encoder 
int CDigitalCaptureLib::SetEncUpDnCounter(int channel,DWORD val)
{
	return DC_SetEncUpDnCounter(card_num,channel,val);
}

int CDigitalCaptureLib::GetEncUpDownCounter(int channel,DWORD *val)
{
	return DC_GetEncoderCounter(cur_card,channel,val);
}

int CDigitalCaptureLib::SetTrgH(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers)
{
	return DC_SetTrgH(cur_card,channel,CountSrc,CntSrcInvert,TrgSrc,TrgSrcInvert,OutInvert,Width,Numbers);
}

int CDigitalCaptureLib::SetTrgV(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers)
{
	return DC_SetTrgV(cur_card,channel,CountSrc,CntSrcInvert,TrgSrc,TrgSrcInvert,OutInvert,Width,Numbers);
}


int CDigitalCaptureLib::SetSyncOut(int channel,int Source,int Invert,int OE)
{
	return DC_SetSyncOut(cur_card,channel,Source,Invert,OE);
}


// PLL control functions
int CDigitalCaptureLib::SetClkOutFreq(int clk_o_number,int ref_number)
{
	return DC_SetClkOutFreq(cur_card,clk_o_number,ref_number);
}

// I2C control functions
void CDigitalCaptureLib::I2C_Init(int channel,int DelayCnt)
{
	DC_I2cInit(cur_card,channel,DelayCnt);
}

void CDigitalCaptureLib::I2C_Rst(int channel)
{
	DC_I2cRst(cur_card,channel);
}

void CDigitalCaptureLib::I2C_Write(int channel,BYTE data)
{
	DC_I2cWrite(cur_card,channel,data);


int CDigitalCaptureLib::I2C_Read(int channel)
{
	return i2c[channel]->GetData();
}

void CDigitalCaptureLib::I2C_Start(int channel)
{
	DC_I2cStart(cur_card,channel);
}

void CDigitalCaptureLib::I2C_Stop(int channel)
{
	DC_I2cStop(cur_card,channel);
}

// EEPROM program
int CDigitalCaptureLib::Prog(void *report, char *filename)
{
	return DC_Prog(cur_card,report,filename);
}

