// Card.h: interface for the CCard class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CARD_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_)
#define AFX_CARD_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCard  
{
public:
	CCard();
	virtual ~CCard();

	int cur_card;

	int GetMaxCards();
	int SelectCard(int card_num)
	int GetCurCard()

	int GetMaxChannels();

	int GetVersion(DWORD *DllVer,DWORD *DrvVer,DWORD *ChipVer);

	int WriteReg(DWORD offset,DWORD data);
	int ReadReg(DWORD offset,DWORD *data);

	int GenIoIrqSet(DWORD ipen, DWORD inen);
	int GenIoRead(DWORD *data);
	int GenIoReadOvl(DWORD *data,DWORD *status);
	int GenIoCancelReadOvl();
	int GenIoWrite(DWORD data);

	int GpioReadIn(int card_num,DWORD *data);
	int GpioWriteOut(int card_num,DWORD data);
	int GpioWriteOE(DWORD data);

	int Open(int channel,int Height,int Width,int Frames,int BitsPerClk);
	int Close(int channel);

	int Start(int channel);
	int Stop(int channel);

	int GetFrame(int channel, BYTE **buf,WORD *pos);
	int CancelGetFrame(int channel);
	int GetFrameAtPos(int channel, WORD pos,BYTE **buf);

	int SetCameraCableMode(int channel,int mode);
	int SetCapInfo(int channel,int HBP, int VBP, int ClkEdgeHigh, int HSyncHigh, int VSyncHigh, int LineArea, int Input10Bits);
	int SetFilter(int channel,DWORD mode,DWORD fsHz,DWORD cutoffHz,int offset,float q);
	int SetExposure(int channel,int enable,int high_active,int width);
	int SetLookupTable(int channel,int index, WORD value);

	// encoder 
	int SetEncUpDnCounter(int channel,DWORD val);
	int GetEncUpDnCounter(int channel,DWORD *val);

	int SetTrgH(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers);
	int SetTrgV(int channel,int CountSrc,int CntSrcInvert,int TrgSrc,int TrgSrcInvert,int OutInvert,WORD Width,WORD Numbers);
	int SetSyncOut(int channel,int Source,int Invert,int OE);

	// PLL control functions
	int SetClkOutFreq(int clk_o_number,int ref_number);

	// I2C control functions
	void I2C_Init(int channel,int DelayCnt);
	void I2C_Rst(int channel);
	void I2C_Write(int channel,BYTE data);
	int I2C_Read(int channel);
	void I2C_Start(int channel);
	void I2C_Stop(int channel);

	// EEPROM program
	int prog(void *report, char *filename);
};

#endif // !defined(AFX_CARD_H__C045D535_742A_48B2_9895_0855108AB82F__INCLUDED_)
