//
// ViewView.cpp : implementation of the CViewView class
//
//
#include "stdafx.h"
#include <mmsystem.h>

#include "dclibdef.h"
#include "View.h"
#include "ViewDoc.h"
#include "ViewView.h"
#include "imglib.h"
#include "../api/inc/mipilib.h"
#include "..\api\inc\EvImgShow.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define		DWIDTH	4096//1280//2048//800//1024//640
//#define		DHEIGHT	2048//960//768//1536//600//768//480//1024


//#define		DWIDTH	4160	// 13M
//#define		DHEIGHT	(3104)  // 59  쿡    3104̴. 
//#define		DWIDTH	4136	// 13M
//#define		DHEIGHT	3102

#define		DWIDTH	1280// 13M
#define		DHEIGHT	960
//#define		DWIDTH	1920// 13M
//#define		DHEIGHT	1080

/////////////////////////////////////////////////////////////////////////////
// CViewView

IMPLEMENT_DYNCREATE(CViewView, CFormView)

BEGIN_MESSAGE_MAP(CViewView, CFormView)
	//{{AFX_MSG_MAP(CViewView)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CAM_RST_CH1, OnButtonCamRstCh1)
	ON_BN_CLICKED(IDC_BUTTON_CH1_SAVE, OnButtonCh1Save)
	ON_BN_CLICKED(IDC_BUTTON_I2C1_WRITE, OnButtonI2c1Write)
	ON_BN_CLICKED(IDC_BUTTON_I2C1_READ, OnButtonI2c1Read)
	ON_BN_CLICKED(IDC_BUTTON_START_CH1, OnButtonStartCh1)
	ON_CBN_SELCHANGE(IDC_COMBO_DISP_MODE, OnSelchangeComboDispMode)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CLK_CHANGE, OnButtonClkChange)
	ON_CBN_SELCHANGE(IDC_COMBO_SELECT_BOARD, OnSelchangeComboSelectBoard)
	ON_CBN_SELCHANGE(IDC_COMBO_OVER_GDI, OnSelchangeComboOverGdi)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
	ON_EN_CHANGE(IDC_EDIT_CLK_FREQ, &CViewView::OnEnChangeEditClkFreq)
	ON_BN_CLICKED(IDC_CHECK_LOGEN, &CViewView::OnBnClickedCheckLogen)
	ON_BN_CLICKED(IDC_BUTTON_SPI, &CViewView::OnBnClickedButtonSpi)
	ON_BN_CLICKED(IDC_BUTTON_UPLOAD, &CViewView::OnBnClickedButtonUpload)
	ON_BN_CLICKED(IDC_CHECK_I2C_SOFT_HW, &CViewView::OnBnClickedCheckI2cSoftHw)
	ON_WM_LBUTTONDOWN()
	ON_EN_CHANGE(IDC_EDIT_STROBE_POS, &CViewView::OnEnChangeEditStrobePos)
	ON_BN_CLICKED(IDC_BUTTON_STRB, &CViewView::OnBnClickedButtonStrb)
	ON_BN_CLICKED(IDC_CHECK_TRG_EN, &CViewView::OnBnClickedCheckTrgEn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewView construction/destruction

UINT ThreadSensorInit(LPVOID lpData){
	CViewView *pView= (CViewView *)lpData;
	return pView->SensorSetup();
}


CViewView::CViewView()
	: CFormView(CViewView::IDD)
	, m_chkLogEn(FALSE)
	, m_edCmd(_T(""))
	, m_chkI2cSoftHw(FALSE)
	, m_cbExposure(_T(""))
	, m_chkTrgEn(FALSE)
	, m_pMipi(NULL)
{
	//{{AFX_DATA_INIT(CViewView)
	m_edClkFreq = 24;
	m_edI2c1Addr = _T("0");
	m_edI2c1Data = _T("0");
	m_edMode = 0;
	m_chkLogEn = FALSE;
	m_fp = NULL;
	m_nStrobePos = 100;


	//}}AFX_DATA_INIT
	// TODO: add construction code here

	sa = 0x5a;

	m_cc = 0;
	m_Ch = 0;
	m_X = 116+120;
	m_Y = 4;
	m_Frames = 10;
	m_FPS = 0;
	m_SlAddr = 0x78;// CE151XX slave address
	m_bRunning = 0;
	m_CapMode = 0;
	m_OverlayEnabled = 0;

	m_dwKeyColor = RGB(0,1,0);

	m_Height = DHEIGHT;
	m_Width = DWIDTH;
	m_PixelBytes = 2;
	m_DispMode = 1;

	CRect rectImage(m_X,m_Y,m_Width+m_X,m_Height+m_Y);
	m_Rect = rectImage;

	m_chkI2cSoftHw = TRUE;
    m_bStretchMode = TRUE;

    m_hMipi = NULL;


	if (!DC_Init()) {;
		m_bBoardInstalled = DC_GetMaxCards();

		DWORD DllVer,DrvVer,ChipVer;

		DC_GetVersion(m_cc,&DllVer,&DrvVer,&ChipVer);

		char buf[256];
		sprintf(buf,"Check Version!!, DllVer = %4x, DrvVer=%4x,ChipVer=%4x",DllVer,DrvVer,ChipVer);
		AfxMessageBox(buf);

		DC_SetClkFreq(m_cc,m_edClkFreq);
	    DC_SetSpiI2cMode(m_cc,1);	// hardware mode 
	    DC_SetHwI2cFreq(m_cc,300);	// 400kHz
	    DC_SetSpiFreq(m_cc, 10);	// 20MHz

		{
			//DC_I2cInit(m_cc,0,6,0);	// low active
			CamReset();
		}

        // mipilib ̺귯 ʱȭ
        int iErrCode = DC_GetMipiHandle(m_cc, 0, &m_hMipi);
        if(iErrCode == DC_ERR_SUCCESS)
        {
			iErrCode = MIPI_Init(m_hMipi, &m_pMipi);
        }
	}
	else {
		m_bBoardInstalled = 0;
		AfxMessageBox("Card Not installed");
	}
}

CViewView::~CViewView()
{
	if (m_bBoardInstalled) {
        // MIPI library release
        MIPI_End(m_hMipi);
        DC_ReleaseMipiHandle(m_cc, 0, m_hMipi);

		DC_End();
	}
}


void CViewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewView)
	DDX_Control(pDX, IDC_LIST_LOG, m_lstLog);
	DDX_Control(pDX, IDC_COMBO_F_MODE, m_cbFreqMode);
	DDX_Control(pDX, IDC_EDIT_TG_V, m_edTgV);
	DDX_Control(pDX, IDC_EDIT_TG_H, m_edTgH);
	DDX_Control(pDX, IDC_EDIT_TG_D9, m_edTgD9);
	DDX_Control(pDX, IDC_EDIT_TG_D8, m_edTgD8);
	DDX_Control(pDX, IDC_EDIT_TG_D7, m_edTgD7);
	DDX_Control(pDX, IDC_EDIT_TG_D6, m_edTgD6);
	DDX_Control(pDX, IDC_EDIT_TG_D5, m_edTgD5);
	DDX_Control(pDX, IDC_EDIT_TG_D4, m_edTgD4);
	DDX_Control(pDX, IDC_EDIT_TG_D3, m_edTgD3);
	DDX_Control(pDX, IDC_EDIT_TG_D2, m_edTgD2);
	DDX_Control(pDX, IDC_EDIT_TG_D1, m_edTgD1);
	DDX_Control(pDX, IDC_EDIT_TG_D0, m_edTgD0);
	DDX_Control(pDX, IDC_EDIT_TG_CLK, m_edTgClk);
	DDX_Control(pDX, IDC_COMBO_OVER_GDI, m_cbOverGdi);
	DDX_Control(pDX, IDC_EDIT_BOARD_NUMBERS, m_edBoardNumbers);
	DDX_Control(pDX, IDC_COMBO_SELECT_BOARD, m_cbSelectBoard);
	DDX_Control(pDX, IDC_EDIT_RATE_CH1, m_edCh1Rate);
	DDX_Control(pDX, IDC_BUTTON_START_CH1, m_btnCaptureStart1);
	DDX_Control(pDX, IDC_COMBO_DISP_MODE, m_cbDispMode);
	DDX_Control(pDX, IDC_COMBO_CH1_MODE, m_cbCh1Mode);
	DDX_Text(pDX, IDC_EDIT_CLK_FREQ, m_edClkFreq);
	DDV_MinMaxUInt(pDX, m_edClkFreq, 0, 80);
	DDX_Text(pDX, IDC_EDIT_I2C1_ADDR, m_edI2c1Addr);
	DDX_Text(pDX, IDC_EDIT_I2C1_DATA, m_edI2c1Data);
	DDX_Text(pDX, IDC_EDIT_MODE, m_edMode);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_CHECK_LOGEN, m_chkLogEn);
	DDX_Text(pDX, IDC_EDIT_CMD, m_edCmd);
	DDX_Check(pDX, IDC_CHECK_I2C_SOFT_HW, m_chkI2cSoftHw);
	DDX_CBString(pDX, IDC_COMBO_EXPOSURE, m_cbExposure);
	DDX_Text(pDX, IDC_EDIT_STROBE_POS, m_nStrobePos);
	DDX_Check(pDX, IDC_CHECK_TRG_EN, m_chkTrgEn);
}

BOOL CViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CFormView::PreCreateWindow(cs);
}

void CViewView::OnInitialUpdate()
{

	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();

	if (!m_bBoardInstalled) return;

	m_cbDispMode.AddString("FULL_CH0");
	m_cbDispMode.AddString("FULL_CH1");
	m_cbDispMode.AddString("SPLIT_H");
	m_cbDispMode.AddString("SPLIT_V");
	m_cbDispMode.SetCurSel(0);

	m_cbCh1Mode.AddString(" 640x512");
	m_cbCh1Mode.AddString("1280x1024");
	m_cbCh1Mode.SetCurSel(0);


	m_cbFreqMode.AddString(" 1x");
	m_cbFreqMode.AddString(" 2x");
	m_cbFreqMode.AddString("x/8");
	m_cbFreqMode.SetCurSel(0);


	m_miData = 0xaa;


	m_edCh1Rate.ReplaceSel("0");

	{
		char buf[30];
		int i;
		int ret;

		for (i=0;i<m_bBoardInstalled;i++) {
			sprintf(buf,"Board = %d",i);
			m_cbSelectBoard.AddString(buf);
		}
		m_cbSelectBoard.SetCurSel(0);

		m_cbOverGdi.AddString("GDI");
		m_cbOverGdi.AddString("Overlay");
		m_cbOverGdi.SetCurSel(0);

		if (m_cbOverGdi.GetCurSel()==1) {
		}
		sprintf(buf,"%d",m_bBoardInstalled);
		m_edBoardNumbers.SetWindowText(buf);
	}
	SetTimer(0, 1000, NULL);
	DWORD data;
	DC_ReadReg(m_cc,0x38,&data);
	lgprintf("Chip compile version = %x",data);
}

/////////////////////////////////////////////////////////////////////////////
// CViewView diagnostics

#ifdef _DEBUG
void CViewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CViewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CViewDoc* CViewView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CViewDoc)));
	return (CViewDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CViewView message handlers

void CViewView::OnPaint() 
{
	if (m_cbOverGdi.GetCurSel()==1) {

		int i;

		RECT SrcRect = {0,0,DWIDTH,DHEIGHT};
		CPaintDC dc(this); // device context for painting

		CBrush pb(m_dwKeyColor);
		RECT rect;

		rect.top = m_Y ;
		rect.left = m_X;
		dc.FillRect(&rect,&pb);
	}
	else {
		int i;
		CPaintDC dc(this); // device context for painting
		Draw(&dc);
	}
}


void CViewView::OnDestroy() 
{
	CFormView::OnDestroy();
	// TODO: Add your message handler code here
	DC_DispClose();
	KillTimer(0);
}

void CViewView::OnButtonCamRstCh1() 
{
	// TODO: Add your control notification handler code here
	CamReset();
	//SensorInit();

}

void CViewView::OnButtonCh1Save() 
{
	// TODO: Add your control notification handler code here

	SaveImage();
	
}

void CViewView::OnButtonI2c1Read() 
{
	UINT chan,addr,data;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	chan = 0;
	sscanf(m_edI2c1Addr,"%4x",&addr);
	m_edI2c1Data.Format("%4x",data);
	UpdateData(FALSE);
	
}

void CViewView::OnButtonI2c1Write() 
{
	UINT chan,addr,data;
	// TODO: Add your control notification handler code here

	UpdateData(TRUE);
	chan = 0;
	sscanf(m_edI2c1Addr,"%4x",&addr);
	sscanf(m_edI2c1Data,"%4x",&data);
	lgprintf("i2c write %x, %x",addr,data);
	
}


void CViewView::OnButtonStartCh1() 
{
	int ch = 0;

	// TODO: Add your control notification handler code here
	if (m_bBoardInstalled) {
		if (!IsRunning()) {
			UpdateData(TRUE);
			Start();
			m_btnCaptureStart1.SetWindowText("Capture Stop");
		}
		else {
			Stop();
			m_btnCaptureStart1.SetWindowText("Capture Start");
		}
	}

}


void CViewView::OnSelchangeComboDispMode() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
}

void CViewView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	if (nIDEvent==0) {

		char buf[30];
		sprintf(buf,"%d",GetFPS());
		m_edCh1Rate.SetWindowText(buf);

		if (!IsRunning()) {
			DWORD data;

			int i = 0;

			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD0.SetWindowText(buf);
			i++;

			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD1.SetWindowText(buf);

			i++;

			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD2.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD3.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD4.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD5.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD6.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD7.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD8.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgD9.SetWindowText(buf);

			i++;
			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgH.SetWindowText(buf);

			i++;

			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgV.SetWindowText(buf);

			i++;

			DC_GetCamLineToggleTimes(m_cc,0,i,&data);
			sprintf(buf,"%d",data);
			m_edTgClk.SetWindowText(buf);

			DC_CheckCamLines(m_cc,0,500);


		}
		else {

			if (1) {
 			//	if(0) 
				//{
				//	//UINT data,data1;

				//	//data = MiRead(0x23);
				//	//data1 = MiRead(0x24);
				//	lgprintf("Get Status = %2x, %X", iStatus, iErrCode);

				//	iErrCode = m_pMipi->GetTotalErrCount(&iEcc1, &iEcc2, &iCrc);

				//	//data = MiRead(0x80);
				//	//data1 = MiRead(0x81);
				//	lgprintf("Get ecc1 cnt = %4x, %X", iEcc1, iErrCode);

				//	//data = MiRead(0x82);
				//	//data1 = MiRead(0x83);
				//	lgprintf("Get ecc2 cnt = %4x", iEcc2);

				//	//data = MiRead(0x84);
				//	//data1 = MiRead(0x85);
				//	lgprintf("Get crc cnt = %4x", iCrc);
				//	//MiWrite(0x24,3);
				//}

				{
					UINT data,data1;

					data = MiRead(0x23);
					data1 = MiRead(0x24);
					lgprintf("Get Status = %2x, %2x",data,data1);

					data = MiRead(0x80);
					data1 = MiRead(0x81);
					lgprintf("Get ecc1 cnt = %4x",(data1<<8)+ data);

					data = MiRead(0x82);
					data1 = MiRead(0x83);
					lgprintf("Get ecc2 cnt = %4x",(data1<<8)+ data);

					data = MiRead(0x84);
					data1 = MiRead(0x85);
					lgprintf("Get crc cnt = %4x",(data1<<8)+ data);
				}

				{
				DWORD data;

				DC_ReadReg(m_cc,0x400c,&data);
				lgprintf("dt=%2x,e1=%1x,e2=%1x,crc=%1x\n",(data>>8) & 0x3f,(data>>2) & 1, (data>>1) & 1, data &1);
				}

			}

			if( 0) {

				BYTE rbuf[10];

				int ack = I2cWrite(1,0x24);
				ack += I2cRead(1,rbuf);
				if (ack) {
					lgprintf("ack err = %x",ack);
					return ;
				}

				lgprintf("AF result = %x",rbuf[0]);
			}
		}


	}
	CFormView::OnTimer(nIDEvent);
}

void CViewView::OnButtonClkChange() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	DC_SetClkFreq(m_cc,m_edClkFreq);
}

void CViewView::OnSelchangeComboSelectBoard() 
{
	// TODO: Add your control notification handler code here
	int i;
	if (IsRunning()) {
		Stop();
	}
	m_cc = m_cbSelectBoard.GetCurSel();
	DC_SetClkFreq(m_cc,m_edClkFreq);

	for (i=0;i<1;i++) {
		DC_I2cInit(m_cc,i,6,0);
		CamReset();
	}

}


BOOL CViewView::CheckFourCC(DWORD dwCode)
{
	DWORD dwCodes[MAX_PATH];
	DWORD dwNumCodes = MAX_PATH;
	if(DC_GetFourCCs(&dwNumCodes, dwCodes) == DC_ERR_SUCCESS)
	{
		for(int i = 0; i < dwNumCodes; i++)
			if(dwCodes[i] == dwCode)
				return TRUE;
	}

	return FALSE;
}



void CViewView::OnSelchangeComboOverGdi() 
{
	// TODO: Add your control notification handler code here

	if (m_cbOverGdi.GetCurSel()==1) {
		DWORD dwCode = MAKEFOURCC('U', 'Y', 'V', 'Y');;
		if(CheckFourCC(dwCode) == FALSE)
		{
			lgprintf("Not Support DDraw to UYVY format");
			return;
		}

		DC_SetFourCC1(dwCode,m_Width*m_PixelBytes,m_Height);
		DC_SetKeyColor(m_dwKeyColor);

		int ret=DC_DispOpen1(GetSafeHwnd(),DWIDTH,DHEIGHT);
		if (ret) {
			lgprintf("Display Surface open errors= %x",ret);
		}
		InvalidateRect(NULL, FALSE);
		m_OverlayEnabled = 1;

	}
	else {
		DC_DispClose();
		m_OverlayEnabled = 0;
	}
}



void CViewView::lgprintf(char *fmt,...)
{
	va_list para;
	va_start(para,fmt);
	vsprintf(m_strMsg,fmt,para);
	va_end(para);
	lgputmsg(m_strMsg);
}

void CViewView::lgputmsg(char *msg)
{
	int cnt = m_lstLog.GetCount();
	m_lstLog.InsertString(cnt,msg);

	if (cnt>=11) {
		m_lstLog.SetTopIndex(cnt-11);
	}
}


// power off
void CViewView::OnButton2() 
{
	// TODO: Add your control notification handler code here
	lgprintf("power off");
	PowerOn(0);
}


// power on
void CViewView::OnButton3() 
{
	UpdateData(TRUE);
	AfxBeginThread(ThreadSensorInit, (LPVOID)(this), THREAD_PRIORITY_NORMAL);
}

// MIPI error status

void CViewView::OnButton4() 
{
	// TODO: Add your control notification handler code here
	int data;
    BYTE bData1;
    int iErrCode = DC_ERR_SUCCESS;

	//data = MiRead(0x23);
	if(m_pMipi) 
		m_pMipi->Read(0x23, &bData1);
    //iErrCode = MIPI_Read(m_hMipi, 0x23, &bData1);
	//data1 = MiRead(0x24);
	if(m_pMipi) 
		iErrCode = m_pMipi->GetError(&data);
    //iErrCode = MIPI_GetError(m_hMipi, &data);
	lgprintf("Get Status = %2x, %2x",bData1, data);

    int iEcc1 = 0, iEcc2 = 0, iCrc = 0;
	if(m_pMipi) 
		iErrCode = m_pMipi->GetTotalErrCount(&iEcc1, &iEcc2, &iCrc);
    //iErrCode = MIPI_GetTotalErrCount(m_hMipi, &iEcc1, &iEcc2, &iCrc);
	//data = MiRead(0x80);
	//data1 = MiRead(0x81);
	lgprintf("Get ecc1 cnt = %4x", iEcc1);

	//data = MiRead(0x82);
	//data1 = MiRead(0x83);
	lgprintf("Get ecc2 cnt = %4x", iEcc2);

	//data = MiRead(0x84);
	//data1 = MiRead(0x85);
	lgprintf("Get crc cnt = %4x", iCrc);
	if(m_pMipi) 
		iErrCode = m_pMipi->ClearError();
    //iErrCode = MIPI_ClearError(m_hMipi);

	DWORD data2;
	DC_ReadReg(m_cc,0x400c,&data2);
	lgprintf("dt_get = %x",data2);
	// clear status
	DC_WriteReg(m_cc,0x400c,1);

	{
	BYTE rbuf[10];
	UINT ack;
	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return ;
	}
	lgprintf("data = %x, ack = %d",rbuf[0],ack);
	}

}





//
int CViewView::SensorSetup()
{
	// TODO: Add your control notification handler code here
	PowerOn(1);
	Sleep(1);

	//////////////////////////////////////// sensor setup

	BYTE rbuf[10];
	UINT ack;

	////////////////////////////////////////////////////////
	// f/w boot
	//
	////////////////////////////////////////////////////////

	lgprintf("fw boot start");
	ack = I2cWrite(1,0xf0);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	else {
		lgprintf("fw boot ok");
	}

	Sleep(610);


	/*
	lgprintf("Get FW version : ");
	ack = I2cWrite(2,0,0);
	ack += I2cRead(4,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("FW version=%x %x %x %x",rbuf[0],rbuf[1],rbuf[2],rbuf[3]);


	lgprintf("Get AF Version : ");
	ack = I2cWrite(2,0,5);
	ack += I2cRead(4,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("AF version=%x %x %x %x",rbuf[0],rbuf[1],rbuf[2],rbuf[3]);

	ack = I2cWrite(2,0,0xa);
	ack += I2cRead(4,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("LSI version=%x %x %x %x",rbuf[0],rbuf[1],rbuf[2],rbuf[3]);

	ack = I2cWrite(9,0x69,0,0,0,0,0x20,0x03,0x58,0x02);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	*/

	lgprintf("Get D0 command: ");
	ack = I2cWrite(2,0xd0);
	ack += I2cRead(8,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("D0 read =%x %x %x %x %x %x %x %x",rbuf[0],rbuf[1],rbuf[2],rbuf[3],rbuf[4],rbuf[5],rbuf[6],rbuf[7]);

	ack = I2cWrite(9,0xd1,0xff,0xff,0xfb,0xdf,0xfb,0xff,0xff,0xff);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}


	//
	//

	ack = I2cWrite(1,0x35);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("24 read =%x",rbuf[0]);

	ack = I2cWrite(1,0x2d);
	ack += I2cRead(2,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("2d read =%x %x",rbuf[0],rbuf[1]);

	ack = I2cWrite(2,0x5b,0x01);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}



	//

	ack = I2cWrite(1,0x35);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("24 read =%x",rbuf[0]);

	ack = I2cWrite(1,0x2d);
	ack += I2cRead(2,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("2d read =%x %x",rbuf[0],rbuf[1]);

	ack = I2cWrite(2,0x20,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("24 read =%x",rbuf[0]);


	ack = I2cWrite(2,0x2c,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}



	//

	ack = I2cWrite(1,0x35);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("24 read =%x",rbuf[0]);

	ack = I2cWrite(1,0x2d);
	ack += I2cRead(2,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("2d read =%x %x",rbuf[0],rbuf[1]);

	ack = I2cWrite(2,0x6b,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}



	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("6c read =%x",rbuf[0]);


	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("6c read =%x",rbuf[0]);


	// system preset 
	//
	// IDLEÿ ȿ
	//
	// 00 : YCO
	// 5 : preset number
	ack = I2cWrite(3,0x05,0x00,0x05);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}


	ack = I2cWrite(3,0x05,0x20,0x01);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}





	// preview resolution 
	//ack = I2cWrite(3,0x54,28,0x03);
//	ack = I2cWrite(3,0x54,31,0x03);
	/*
	ack = I2cWrite(3,0x54,0x1c,1);//0x03);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	*/

	// 
	
	/*
	//ack = I2cWrite(3,0x5a,60,0);
	ack = I2cWrite(3,0x5a,0x1e,0);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	*/

	// buffring Կ

	/*
	//ack = I2cWrite(6,0x73,0x2f,0x0,0x0,0x0,0x0);
	ack = I2cWrite(5,0x73,0x2f,0x0,0x2,0x0);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	*/

	/*

	// AE,AWB on
	ack = I2cWrite(2,0x11,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	*/


	/*
	//NEC preview start
	ack = I2cWrite(2,0x6b,0x01);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	Sleep(200);

	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("data = %x, ack = %d",rbuf[0],ack);
	*/

	// preview -> Live View ȯ

	/*
	ack = I2cWrite(2,0x6b,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	Sleep(200);
	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("data = %x, ack = %d",rbuf[0],ack);

	*/

	//
	//  ϰ ݿ 䱸
	//
	// FW command ϰ о ݿŲ. 
	//

//	ack = I2cWrite(2,0x1,0x0);
//	if (ack) {
//		lgprintf("ack err = %x",ack);
//		return 0;
//	}

	//
	// ISP mode , 
	// 
	// IDLEÿ ȿ,   5ms 
//	ack = I2cWrite(2,0x3,0x05);
//	ack += I2cRead(1,rbuf);
//	if (ack) {
//		lgprintf("ack err = %x",ack);
//		return 0;
//	}
//	lgprintf("data = %x, ack = %d",rbuf[0],ack);
//	Sleep(5);



	//
	// Preview 
	// Preview  ¿ ȿ
	//    
	// 
	// ù° Ķ͸ preview ϰ ϴ Ʈ ϸ 
	//ISP ˾Ƽ   带 ϰ Ÿ ͼ óϴ 
	// . 

	ack = I2cWrite(3,0x54,28,0);	// 1280x960
//	ack = I2cWrite(3,0x54,49,0);//0xb);	// rate  
//	ack = I2cWrite(3,0x54,47,0);	// 5-6 frame
//	ack = I2cWrite(3,0x54,30,0);	// 5-6 frame
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	// preview rate
	//
	// Preview Ŀ Preview  ̿ . 
	//
	//
	//

//	ack = I2cWrite(3,0x5a,60,0);
//	if (ack) {
//		lgprintf("ack err = %x",ack);
//		return 0;
//	}

	// ȭ  
	//
	//   
	//
	//
	//
	//
	//

//	ack = I2cWrite(3,0x3d,0x02,0x0);
//	if (ack) {
//		lgprintf("ack err = %x",ack);
//		return 0;
//	}



	// preview assist mode , ȭ
	ack = I2cWrite(2,0x40,0);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}


	// AF macro, near to far method
//	ack = I2cWrite(2,0x20,1);
//	if (ack) {
//		lgprintf("ack err = %x",ack);
//		return 0;
//	}
//	Sleep(2);

	//
	// AE,AWB on
	//
	// AE/WB Lock or not
	//
	// bit 4 : WB lock , 1: lock, 0 : unlock
	//
	// bit 0 : AE lock,  1 : lock, 0 : unlock
	//
	//

	ack = I2cWrite(2,0x11,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}


	// Live View start
	//
	// Preview  ϴ ɰ ϴ. 
	//
	//
	//
	//
	ack = I2cWrite(2,0x65,0x01);  // live view start
//	ack = I2cWrite(2,0x6b,0x01); // preview start
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	//
	//
	//

	Sleep(200);
	ack = I2cWrite(1,0x6c);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("check data 0x17, data = %x, ack = %d",rbuf[0],ack);


	ack = I2cWrite(1,0x35);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	Sleep(10);
	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("check data 24 cmd, data = %x, ack = %d",rbuf[0],ack);



	ack = I2cWrite(1,0x2d);
	ack += I2cRead(2,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("check data 24 cmd, data = %x, ack = %d",rbuf[0],ack);

	ack = I2cWrite(2,0x20,0x00);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}

	Sleep(10);
	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}
	lgprintf("check data 24 cmd, data = %x, ack = %d",rbuf[0],ack);


	ack = I2cWrite(2,0x2c,0x01);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 0;
	}




	return 0;
}

void CViewView::OnEnChangeEditClkFreq()
{
	// TODO:  RICHEDIT Ʈ ,  Ʈ
	// CFormView::OnInitDialog() Լ  
	//ϰ ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ CRichEditCtrl().SetEventMask() ȣ 
	//  ˸ ޽  ʽϴ.
	// TODO:  ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
}

void CViewView::OnBnClickedCheckLogen()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	if (m_fp) {
		fclose(m_fp);
		m_fp = NULL;
		m_chkLogEn = FALSE;
	}
	else {
		m_chkLogEn = TRUE;
		m_fp = fopen("log.txt","wt");
	}
	UpdateData(FALSE);
}

void CViewView::OnBnClickedButtonSpi()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UINT ack;
	BYTE rbuf[10];

	ack = I2cWrite(1,0x23);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return ;
	}
	Sleep(33);

	ack = I2cWrite(1,0x24);
	ack += I2cRead(1,rbuf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return ;
	}

	lgprintf("AF result = %x",rbuf[0]);
	//Sleep(10);
	//ack = I2cWrite(2,0x2c,0x01);


}




void CViewView::CamReset() 
{
	// TODO: Add your control notification handler code here
	if (m_chkI2cSoftHw) {
		DC_I2cRst(m_cc,m_Ch);// 2ms
	}
	else {
		// 2ms
		MIPI_CamReset(m_hMipi, 2);
        //MIPI_CamReset(m_hMipi, 1);
        //Sleep(2);
        //MIPI_CamReset(m_hMipi, 0);
	}

}


char *CViewView::Draw(CPaintDC *dc)
{
	if (m_bRunning) {
		if (m_DispMode==1) {
			
			
			BITMAPINFOHEADER m_bmiHdr;
			BITMAPFILEHEADER m_bmfHdr;

			MakeBMPHeader(&m_bmiHdr, &m_bmfHdr, m_Width, m_Height);
			SetDIBitsToDevice(dc->m_hDC, m_X, m_Y,	m_bmiHdr.biWidth, m_bmiHdr.biHeight,
								0, 0, 0, (WORD)m_bmiHdr.biHeight, m_BmpImage,
								(LPBITMAPINFO)&m_bmiHdr, BI_RGB);

			return (char *)m_DispBuf;
		}

	}

	return NULL;
}

void CViewView::SaveImage()
{
	char name[255];

	time_t osBinaryTime;  // C run-time time (defined in <time.h>)
	time( &osBinaryTime ) ;  // Get the current time from the 
							 // operating system.
	CTime time3(osBinaryTime );  

	sprintf(name,"img%1d_%4d%02d%02d%02d%02d%02d.bmp",m_Ch,time3.GetYear(),time3.GetMonth(),time3.GetDay(),time3.GetHour(),time3.GetMinute(),time3.GetSecond());

	YUVtoBMPImage((BYTE *)m_DispBuf, m_BmpSaveImage,m_Width, m_Height);
	WriteBMPImage(name, m_BmpSaveImage,m_Width,m_Height);
}


// call this function every one second
int CViewView::GetFPS()
{
	int ret;
	ret = m_FPS;
	m_FPS = 0;
	return ret;
}


BOOL CViewView::IsRunning()
{
	return m_bRunning;
}


UINT ThreadFunc(LPVOID lpData){
	CViewView *pView = (CViewView *)lpData;
	return pView->Capture();
}


void CViewView::Start()
{
	m_bRunning = TRUE;
	AfxBeginThread(ThreadFunc, (LPVOID)(this), THREAD_PRIORITY_NORMAL);
}


void CViewView::Stop()
{
	m_bRunning = FALSE;
	DC_CancelGetFrame(m_cc,m_Ch);
}


UINT CViewView::Capture()
{
	RECT rect;
	RECT SrcRect = {0,0,DWIDTH,DHEIGHT};

	DC_Open(m_cc,m_Ch,m_Height,m_Width*m_PixelBytes,m_Frames,8);	// YUV mode
	DC_SetCapInfo(	
		m_cc,
		m_Ch,
		0,	// HBP
		0,	// VBP
		1,	// ClkEdgeHigh
		1,	// HSyncEdgeHigh
		1,	// VSyncEdgeHigh
		0,	// LineArea
		0,	// Input10Bits
		0
	);

	//
	//
	//

	DC_Start(m_cc,m_Ch);

	BYTE *buf;
	WORD length;
	char tt[255];
	int fc = 0;

	int ret;
	while(m_bRunning){

		do {
			ret = DC_GetFrame(m_cc,m_Ch,1,&buf,&length,NULL);
			if (ret) {
				lgprintf("Error = %x, %s",ret,DC_GetErrorMsg(ret));
			}
			else {
				m_FPS++;
				fc++;
				//lgprintf("fc= %d,l=%d",fc,length);
			}
			if (length==1) break; // get the latest frame 
		}
		while (1);

		if (length>0 && buf)  {
			if (m_OverlayEnabled) {

				GetWindowRect(&rect);
				rect.top += m_Y;
				rect.left += m_X;
			
				SrcRect.right=m_Width;
				SrcRect.bottom=m_Height;
				
				// STRETCH ɼ üũ
				if(m_bStretchMode == FALSE)
				{
					if (SrcRect.bottom<(rect.bottom+1-rect.top)) {
						rect.bottom = SrcRect.bottom + rect.top;
						rect.right = SrcRect.right + rect.left;
					}
					else {
						SrcRect.right=rect.right-rect.left+1;
						SrcRect.bottom=rect.bottom-rect.top+1;
					}
				}
				else
				{
					// STRETCH DRAW
					CRect rcSrc(SrcRect);
					CRect rcRect(rect);
					double dSrcRatio = (float)rcSrc.Width() / rcSrc.Height();
					double dDstRatio = (float)rcRect.Width() / rcRect.Height();

					if(dSrcRatio > dDstRatio)
					{
						//  ̰   
						int iVariation = rcSrc.Height() * rcRect.Width() / rcSrc.Width();
						rect.bottom = rect.top + iVariation;
						//TRACE("H: %d (%d,%d,%d,%d)\n", iVariation, rect.left, rect.top, rect.right, rect.bottom);
					}
					else
					{
						//  ̺   
						int iVariation = rcSrc.Width() * rcRect.Height() / rcSrc.Height();
						rect.right = rect.left + iVariation;
						//TRACE("W: %d (%d,%d,%d,%d)\n", iVariation, rect.left, rect.top, rect.right, rect.bottom);
					}
				}

				DC_SetShowRect(&SrcRect,&rect);
				memcpy(m_DispBuf,buf,m_Width*m_Height*m_PixelBytes);
				DC_Update1((unsigned char *)m_DispBuf);	// non flip method
			}
			else {
				if (m_DispMode) {
					//evShowImage( "Capture", m_Width, m_Height, buf, m_Width*m_Height*m_PixelBytes, EV_DT_Y422 );

					memcpy(m_DispBuf,buf,m_Width*m_Height*m_PixelBytes);
					////YUVtoBMPImage((BYTE *)m_DispBuf, m_BmpImage,m_Width, m_Height); // 2-lane yuv 
					YUVtoBMPImage((BYTE *)m_DispBuf, m_BmpImage,m_Width, m_Height);  // 4-lane yuv
					////RAW10toBMPImage((BYTE *)m_DispBuf, m_BmpImage,m_Width, m_Height);
					////RAW12toBMPImage((BYTE *)buf, m_BmpImage,m_Width, m_Height);
					InvalidateRect(&m_Rect, FALSE);
				}
			}
			//WriteRAWImage("img.raw", (BYTE *)buf, m_Width,m_Height);
		}
	}
	DC_Stop(m_cc,m_Ch);
	DC_Close(m_cc,m_Ch);
	return 0;
}



int CViewView::PowerOn(int on)
{
	// TODO: Add your control notification handler code here
//	MiWrite(16,1);	// enable external i2c

	DC_I2cClkStretchEn(m_cc,0,1);
	DC_GpioWriteOE(m_cc,0xffffff);
//	DC_GpioWriteOut(m_cc,(1<<8));
//	Sleep(1);
	DC_GpioWriteOut(m_cc,0);
	Sleep(1);
	//MiWrite(1,0xff);	// OE enable
	//MiWrite(0,0xff & ~(1<<7));	// power dn bit7 low before power on
	//MiWrite(0,0xff );	
	//DC_WriteReg(m_cc,0x8b0,0);	// reset low

	if(m_pMipi) 
	{
		m_pMipi->SetGpioOE(0xff);
		m_pMipi->SetGpio(0xff);
	}
    //MIPI_SetGpioOE(m_hMipi, 0xff);
    //MIPI_SetGpio(m_hMipi, 0xff);

	if (!on) return 0;

	//power on
	Sleep(1);

	{
	DWORD data = 0;
//	data |= (1<<8); // core power on
//	DC_GpioWriteOut(m_cc,data);
//	Sleep(10);
	data |= 0xffffff;
	DC_GpioWriteOut(m_cc,data);
	}

	Sleep(1);

	//MiWrite(0,0xff);	// power dn bit7 high
	if(m_pMipi) 
		m_pMipi->SetGpio(0xff);
    //MIPI_SetGpio(m_hMipi, 0xff);
	lgprintf("Cam reset");
	CamReset();
	Sleep(1200);

	/////////////////////////////////////////////////////////
	BYTE vc,dt,lanes,e8b9b;

	// YUV, 4-lane, vc=0,dt=0x1e
	vc = 0;
	dt = 0x1e;	// YUV
	lanes = 4;
	e8b9b = 0;

	//vc_dt = 0x2b;	// RAW10
	//vc_dt = 0x2c;	// RAW12

	//MiWrite(0x21,1);				// mipi reset active

	//MiWrite(0x22,0);
	//MiWrite(0x23,(vc<<5) | dt);	// set MIPI vc,dt;

	// mipi receiver init
	//MiWrite(0x20,(e8b9b<<4) | (lanes-1));	// lane numbers=3, and en 8b9b=0
	if(m_pMipi) 
		m_pMipi->SetMipiControl(vc, dt, e8b9b, lanes);
    //MIPI_SetMipiControl(m_hMipi, vc, dt, e8b9b, lanes);
	//MiWrite(0x21,0);				// reset release

	// set framegrabber MIPI VC & data type
	DC_SetMipiInfo(m_cc,0,vc, dt);//
	DC_WriteReg(m_cc,0x4008,(0<<0) | (0<<0) | (0<<3) | (0<<2) | (lanes-1) ); // 

	// get version of the MIPI board
	UINT data,data1;
	data = MiRead(254);
	data <<= 8;
	data |= MiRead(255);
	data1 = MiRead(16);
	lgprintf("id = %x, addr 0x10 = %x",data, data1);

    int iChipId = 0, iSpiEnable, iApiVer = 0;
	if(m_pMipi) 
		m_pMipi->GetVersion(NULL, &iChipId, &iApiVer);
    //MIPI_GetVersion(m_hMipi, NULL, &iChipId, &iApiVer);
 	if(m_pMipi) 
		m_pMipi->GetSpiEnable(&iSpiEnable);
   //MIPI_GetSpiEnable(m_hMipi, &iSpiEnable);
	lgprintf("id = %x, api = %x, addr 0x10 = %x",iChipId, iApiVer, iSpiEnable);
};



int CViewView::SensorFWUpdate()
{
	// TODO: Add your control notification handler code here
	PowerOn(1);

	//////////////////////////////////////// sensor setup

	BYTE buf[10];
	UINT ack;

	BYTE st;
	int cnt;

	lgprintf("fw loader info");
	Upload(0xa0,"CE150F01.BIN");
	Sleep(200);

	lgprintf("Get status");
	ack = I2cReadCmd(0xf5,1,&st);
	if (!(st==0x05 || st==0x04 )) {
		lgprintf("status = %x fails",st);
		return 1;
	}

	ack = I2cReadCmd(0xf2,2,buf);
	lgprintf("Upload version = %x %x",buf[0],buf[1]);

	Sleep(300);

	Upload(0x2210,"CE150F03.BIN");
	Sleep(200);

	lgprintf("Get status");
	ack = I2cReadCmd(0xf5,1,&st);
	if (st!=0x05) {
		lgprintf("status = %x fails",st);
		return 1;
	}
	Sleep(100);
}


int CViewView::Upload(long frame_size,char *filename)
{

	FILE *fp;
	BYTE buf[256];
	int ack;

	lgprintf("Upload size=%d, fn=%s",frame_size,filename);
	buf[0] = m_SlAddr;
	buf[1] = 0xf2;
	buf[2] = frame_size & 0xff;
	buf[3] = (frame_size>>8) & 0xff;
	buf[4] = 0xff;
	buf[5] = (~(buf[2]+buf[3]+buf[4]) & 0xff) + 1;
	lgprintf("buf = %x %x %x %x %x",buf[1],buf[2],buf[3],buf[4],buf[5]);

	ack = ComI2cWrite(6,1,1,buf);
	if (ack) {
		lgprintf("ack err = %x",ack);
		return 1;
		//return;
	}
	else {
		lgprintf("bin info send ok");
	}

	Sleep(100);

	fp = fopen(filename,"rb");

	if (fp==NULL) {
		lgprintf("File %s not found");
		return 1;
	}

	// binary
	BYTE chksum;
	int block_len = 129;
	BYTE st;
	int rd_len;

	int fn;

	for (fn=0;fn<frame_size;fn++) {

		rd_len = fread(&buf[2],1,block_len,fp);

		buf[0] = m_SlAddr;
		buf[1] = 0xf3;

		ack += ComI2cWrite(block_len+2,1,0,buf);

		
		buf[0] = m_SlAddr+1;

		ComI2cWrite(1,1,0,buf);
		ComI2cRead(1,1,&st);
		
		lgprintf("f=%d/%d,result=%x,r_l=%x",fn+1,frame_size,st,rd_len);
	}
	fclose(fp);
	return st;

}


void CViewView::OnBnClickedButtonUpload()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	int ret = SensorFWUpdate();
}


//
// MIPI 4-lane board I2C functions
//

int CViewView::MiWrite(UINT addr,UINT data)
{
	//
	// 8bit I/O method
	int ack = 0;
	BYTE buf[] = {0xca,addr,data};
	ack = ComI2cWrite(3,1,1,buf);
	TRACE("MiWrite ack = %d\n", ack);
	return ack;
}

int CViewView::MiRead(UINT addr)
{
	BYTE buf[5];
	int ack = 0;

	// 8bit I/O method
	buf[0] = 0xca;
	buf[1] = addr;
	ack += ComI2cWrite(2,1,0,buf);

	buf[0] = 0xca+1;
	ack += ComI2cWrite(1,1,0,buf);

	ack += ComI2cRead(1,1,buf);
	TRACE("MiRead ack = %d\n", ack);
	return buf[0];
}


//
//
// sensor I2C functions
//
//

int	CViewView::I2cRead(int numbers,BYTE *data)
{
	BYTE sa = m_SlAddr+1;
	int ack;
	ack = ComI2cWrite(1,1,0,&sa);
	ComI2cRead(numbers,1,data);
	return ack;
}



int	CViewView::I2cWrite(int numbers,...)
{

	BYTE buf[256];

	buf[0] = m_SlAddr;

	va_list vl;
	va_start(vl,numbers);
	for (int i=0;i<numbers;i++) {
		buf[i+1] = va_arg(vl,char);
	}
	va_end(vl);


	int ack = ComI2cWrite(numbers+1,1,1,buf);

	return ack;
}


int CViewView::I2cReadCmd(BYTE cmd,int len,BYTE *rbuf)
{
	int ack;
	BYTE buf[4];

	buf[0] = m_SlAddr;
	buf[1] = cmd;

	ack = ComI2cWrite(2,1,0,buf);

	buf[0] = m_SlAddr+1;

	ack += ComI2cWrite(1,1,0,buf);
	ComI2cRead(len,1,rbuf);
	return ack;
}

int CViewView::ComI2cWrite(int len,int start,int last,BYTE *buf)
{
	if (m_chkI2cSoftHw) {
		return DC_SoftI2cWrite(m_cc,0,len,start,last,buf);
	}
	return DC_HwI2cWrite(m_cc,len,start,last,buf);

}

int CViewView::ComI2cRead(int len,int last,BYTE *buf)
{
	if (m_chkI2cSoftHw) {
		return DC_SoftI2cRead(m_cc,0,len,last,buf);
	}
	return DC_HwI2cRead(m_cc,len,last,buf);
}





void CViewView::OnBnClickedCheckI2cSoftHw()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	if (m_chkI2cSoftHw) {
		DC_SetSpiI2cMode(m_cc,0);
	}
	else {
		DC_SetSpiI2cMode(m_cc,1);
	}
}

void CViewView::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (nFlags & MK_LBUTTON) {

		lgprintf("pos %d, %d",point.x,point.y);
		//
		// calculate the source position from the mouse position to forcus the object
		//
		//

		RECT rect;
		RECT SrcRect = {0,0,DWIDTH,DHEIGHT};

		GetWindowRect(&rect);
		rect.top += m_Y;
		rect.left += m_X;

		SrcRect.right=m_Width;
		SrcRect.bottom=m_Height;
		//lgprintf("l=%d,r=%d,t=%d,b=%d",rect.left,rect.right,rect.top,rect.bottom);

		// STRETCH DRAW
		CRect rcSrc(SrcRect);
		CRect rcRect(rect);

		double dSrcRatio = rcSrc.Width() / rcSrc.Height();
		double dDstRatio = rcRect.Width() / rcRect.Height();

		if(dSrcRatio > dDstRatio)
		{
			//  ̰   
			int iVariation = rcSrc.Height() * rcRect.Width() / rcSrc.Width();
			rect.bottom = rect.top + iVariation;
			//TRACE("H: %d (%d,%d,%d,%d)\n", iVariation, rect.left, rect.top, rect.right, rect.bottom);
		}
		else
		{
			//  ̺   
			int iVariation = rcSrc.Width() * rcRect.Height() / rcSrc.Height();
			rect.right = rect.left + iVariation;
			//TRACE("W: %d (%d,%d,%d,%d)\n", iVariation, rect.left, rect.top, rect.right, rect.bottom);
		}

		CPoint srcPoint;
		double sdRatio = (double)(rcSrc.Height())/(rect.bottom +1 - rect.top);

		if ( (point.x>=m_X && point.x<=(1+rect.right-rect.left+m_X)) && (point.y>=m_Y && point.y<=(1+rect.bottom-rect.top+m_Y))) {
			srcPoint.x = (point.x - m_X)*sdRatio;
			srcPoint.y = (point.y - m_Y)*sdRatio;

			lgprintf("src pos %f, %d, %d",sdRatio,srcPoint.x,srcPoint.y);

			DWORD y = srcPoint.y;
			DWORD x = srcPoint.x;

			DWORD ltx,lty,rbx,rby;

			int ack;
			ltx = x-100;
			lty = y-100;
			rbx = x+100;
			rby = y+100;




			//int ack = I2cWrite(9,0x4d,1,3,1,srcPoint.x & 0xff, srcPoint.x>>8,y & 0xff, y>>8,(srcPoint.x+10) & 0xff, (srcPoint.x+10)>>8,(y+10) & 0xff, (y+10)>>8);
//			ack = I2cWrite(11,0x41,0x10,0xb2,(x-32)&0xff,(x-32)>>8,(y-32)&0xff,(y-32)>>8,(x+32) & 0xff,(x+32)>>8,(y+32)&0xff,(y+32)>>8);
//			ack = I2cWrite(11,0x41,0x10,0xb2,(x-16)&0xff,(x-16)>>8,(y-16)&0xff,(y-16)>>8,(x+16) & 0xff,(x+16)>>8,(y+16)&0xff,(y+16)>>8);
			ack = I2cWrite(11,0x41,0x10,0xb2,ltx&0xff,ltx>>8,lty&0xff,lty>>8,rbx & 0xff,rbx>>8,rby&0xff,rby>>8);
			ack += I2cWrite(2,0x42,05);
			{
			BYTE rbuf[10];
			UINT ack;
			ack = I2cWrite(1,0x43);
			ack += I2cRead(1,rbuf);
			if (ack) {
				lgprintf("ack err = %x",ack);
				//return ;
			}
			lgprintf("data = %x, ack = %d",rbuf[0],ack);

			ack = I2cWrite(1,0x43);
			ack += I2cRead(1,rbuf);
			if (ack) {
				lgprintf("ack err = %x",ack);
				//return ;
			}
			lgprintf("data = %x, ack = %d",rbuf[0],ack);
			}


			Sleep(30);
//			ack = I2cWrite(11,0x41,0x20,0xb2,(x-64)&0xff,(x-64)>>8,(y-64)&0xff,(y-64)>>8,(x+64) & 0xff,(x+64)>>8,(y+64)&0xff,(y+64)>>8);
//			ack = I2cWrite(11,0x41,0x20,0xb2,(x-32)&0xff,(x-32)>>8,(y-32)&0xff,(y-32)>>8,(x+32) & 0xff,(x+32)>>8,(y+32)&0xff,(y+32)>>8);
//			ack = I2cWrite(11,0x41,0x10,0xb2,ltx&0xff,ltx>>8,lty&0xff,lty>>8,rbx & 0xff,rbx>>8,rby&0xff,rby>>8);
			ack = I2cWrite(11,0x41,0x10,0xb2,ltx&0xff,ltx>>8,lty&0xff,lty>>8,rbx & 0xff,rbx>>8,rby&0xff,rby>>8);
			//ack += I2cWrite(10,0x41,0x20,0xb2,x&0xff,x>>8,y&0xff,y>>8,(x+512) & 0xff,(x+512)>>8,(y+512)&0xff,(y+512)>>8);
			ack += I2cWrite(2,0x42,05);
			Sleep(30);
			{
			BYTE rbuf[10];
			UINT ack;
			ack = I2cWrite(1,0x43);
			ack += I2cRead(1,rbuf);
			if (ack) {
				lgprintf("ack err = %x",ack);
				//return ;
			}
			lgprintf("data = %x, ack = %d",rbuf[0],ack);

			ack = I2cWrite(1,0xd0);
			ack += I2cRead(8,rbuf);
			if (ack) {
				lgprintf("ack err = %x",ack);
				//return ;
			}
			lgprintf("data = %x %x %x %x %x %x %x %x , ack = %d",rbuf[0],rbuf[1],rbuf[2],rbuf[3],rbuf[4],rbuf[5],rbuf[6],rbuf[7],ack);


			ack = I2cWrite(1,0x51);
			ack += I2cRead(9,rbuf);
			if (ack) {
				lgprintf("ack err = %x",ack);
				//return ;
			}
			lgprintf("data = %x %x %x %x %x %x %x %x %x, ack = %d",rbuf[0],rbuf[1],rbuf[2],rbuf[3],rbuf[4],rbuf[5],rbuf[6],rbuf[7],rbuf[8],ack);
			}


			if (ack) {
				lgprintf("ack err = %x",ack);
			}

			//Sleep(1);
			//OnBnClickedButtonSpi();
		}
		

	}






}


void CViewView::OnEnChangeEditStrobePos()
{
	// TODO:  RICHEDIT Ʈ ,  Ʈ
	// CFormView::OnInitDialog() Լ  
	//ϰ ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ CRichEditCtrl().SetEventMask() ȣ 
	//  ˸ ޽  ʽϴ.

	// TODO:  ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.

}

void CViewView::OnBnClickedButtonStrb()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	MiWrite(0x26,m_nStrobePos & 0xff);
	MiWrite(0x27,m_nStrobePos>>8);

}

void CViewView::OnBnClickedCheckTrgEn()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	UpdateData(TRUE);
	if (m_chkTrgEn) {
		MiWrite(0x28,1);
	}
	else {
		MiWrite(0x28,0);
	}

}
