// ViewView.h : interface of the CViewView class
//
/////////////////////////////////////////////////////////////////////////////

#include "afxwin.h"
#if !defined(AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_)
#define AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class IMipi;

class CViewView : public CFormView
{
protected: // create from serialization only
	CViewView();
	DECLARE_DYNCREATE(CViewView)

public:
	//{{AFX_DATA(CViewView)
	enum { IDD = IDD_VIEW_FORM };
	CListBox	m_lstLog;
	CComboBox	m_cbFreqMode;
	CEdit	m_edTgV;
	CEdit	m_edTgH;
	CEdit	m_edTgD9;
	CEdit	m_edTgD8;
	CEdit	m_edTgD7;
	CEdit	m_edTgD6;
	CEdit	m_edTgD5;
	CEdit	m_edTgD4;
	CEdit	m_edTgD3;
	CEdit	m_edTgD2;
	CEdit	m_edTgD1;
	CEdit	m_edTgD0;
	CEdit	m_edTgClk;
	CComboBox	m_cbOverGdi;
	CEdit	m_edBoardNumbers;
	CComboBox	m_cbSelectBoard;
	CEdit	m_edCh1Rate;
	CButton	m_btnCaptureStart1;
	CComboBox	m_cbDispMode;
	CComboBox	m_cbCh1Mode;
	UINT	m_edClkFreq;
	CString	m_edI2c1Addr;
	CString	m_edI2c1Data;
	int		m_edMode;
	//}}AFX_DATA

// Attributes
public:
	CViewDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CViewView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:


	int m_bBoardInstalled;

	DWORD m_dwKeyColor;

	virtual ~CViewView();

	int SensorSetup();
	BYTE m_miData;

	char	m_strMsg[255];
	void lgprintf(char *fmt,...);
	void lgputmsg(char *msg);


	UCHAR m_SlAddr;
	int sa;

	void CamReset(); 

	void DispMipiInfo();

	FILE *m_fp;

	IMipi *m_pMipi;


	int m_cc;	// current card number
	int m_Ch;
	int m_Height;
	int m_Width;
	int m_Frames;
	int m_FPS;
	CRect m_Rect;
	BYTE m_BmpImage[5000*5000*3];	// RGB
	BYTE m_BmpSaveImage[5000*5000*3];	// RGB
	int m_X;
	int m_Y;
	BOOL m_bRunning;
	int m_CapMode;
	int m_DispMode;

	BYTE m_DispBuf[5000*5000*2];	// YUV
	float m_PixelBytes;
	int m_OverlayEnabled;
	int m_bStretchMode ;

    // MIPI ̺귯 ϱ  HANDLE
    HANDLE m_hMipi;



	int	I2cRead(int numbers,BYTE *data);
	int	I2cWrite(int numbers,...);
	int I2cReadCmd(BYTE cmd,int len,BYTE *rbuf);


	int ComI2cWrite(int len,int start,int last,BYTE *buf);
	int ComI2cRead(int len,int last,BYTE *buf);

	int MiWrite(UINT addr,UINT data);
	int MiRead(UINT addr);

	UINT Capture();
	char *Draw(CPaintDC *dc);
	int GetFPS();
	void Start();
	void Stop();
	BOOL IsRunning();
	void SaveImage();

	int PowerOn(int on);

	int SensorFWUpdate();
	int Upload(long frame_size,char *filename);
	BOOL CheckFourCC(DWORD dwCode);
	int m_SStart;


#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CViewView)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnButtonCamRstCh1();
	afx_msg void OnButtonCh1Save();
	afx_msg void OnButtonI2c1Read();
	afx_msg void OnButtonI2c1Write();
	afx_msg void OnButtonStartCh1();
	afx_msg void OnSelchangeComboDispMode();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnButtonClkChange();
	afx_msg void OnSelchangeComboSelectBoard();
	afx_msg void OnSelchangeComboOverGdi();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
//	afx_msg void OnButtonI2c1Write();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnEnChangeEditClkFreq();
	BOOL m_chkLogEn;
	afx_msg void OnBnClickedCheckLogen();
	afx_msg void OnBnClickedButtonSpi();
	CString m_edCmd;
	afx_msg void OnBnClickedButtonUpload();
	BOOL m_chkI2cSoftHw;
	afx_msg void OnBnClickedCheckI2cSoftHw();
	afx_msg void OnLButtonDown(UINT, CPoint);

	CString m_cbExposure;
	UINT m_nStrobePos;
	afx_msg void OnEnChangeEditStrobePos();
	afx_msg void OnBnClickedButtonStrb();
	BOOL m_chkTrgEn;
	afx_msg void OnBnClickedCheckTrgEn();
	CButton m_btnSensorStartStop;
	afx_msg void OnBnClickedButtonNear();
	afx_msg void OnBnClickedButtonFar();
};

#ifndef _DEBUG  // debug version in ViewView.cpp
inline CViewDoc* CViewView::GetDocument()
   { return (CViewDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIEWVIEW_H__BC8E86CC_787D_11D5_AF58_00A024CDB4CE__INCLUDED_)
